Attribute VB_Name = "InfoSistema"
'Mdulo necesario para el AddIn ProcErr

'Santiago Oliver
'www.oliware.com
'admin@oliware.com

'Mdulo con muchas funciones con informacin del sistema
'La funcion InfoSys resume todas estas funciones para darnos en una cadena
'un completo informe sobre el sistema.
'Se utiliza desde la clase ClsErrores para mostrar la informacin del
'ordenador del usuario en el cuerpo del mensaje enviado por email con el
'archivo log adjunto con los errores.
'Tambin se puede usar desde cualquier otro sitio, por ejemplo:

'Text1.Text = InfoSys

Option Explicit
'===================
' Private Constants
'===================
Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2
Private Const SM_MOUSEPRESENT = 19
Private Const DRIVE_UNKNOWN = 0
Private Const DRIVE_NO_ROOT_DIR = 1
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6
Private Const PROCESSOR_ALPHA_21064 = 21064
Private Const PROCESSOR_INTEL_386 = 386
Private Const PROCESSOR_INTEL_486 = 486
Private Const PROCESSOR_INTEL_PENTIUM = 586
Private Const PROCESSOR_MIPS_R4000 = 4000
Private Const HORZRES = 8
Private Const VERTRES = 10
Private Const BITSPIXEL = 12
Private Const PLANES = 14
Private Const SM_CMONITORS = 80
Private Const SM_CMOUSEBUTTONS = 43
Private Const SM_MOUSEWHEELPRESENT = 75
Private Const LOCALE_SNATIVELANGNAME = &H4
Private Const LOCALE_SNATIVECTRYNAME = &H8
Public Const LOCALE_SDATE = &H1D           '  separador de fecha
Public Const LOCALE_STIME = &H1E           '  separador de hora
Public Const LOCALE_SDECIMAL = &HE         '  separador de decimales
Public Const LOCALE_STIMEFORMAT = &H1003   '  cadena de formato de hora
Public Const LOCALE_SSHORTDATE = &H1F      '  cadena de formato de fecha corta
Public Const LOCALE_SLONGDATE = &H20       '  cadena de formato de fecha larga
Private Const SM_DBCSENABLED = 42
Private Const SM_MIDEASTENABLED = 74
'Const S_OK = &H0
'Const S_FALSE = &H1
'Const E_INVALIDARG = &H80070057
Private Const SHGFP_TYPE_CURRENT = 0
'Const SHGFP_TYPE_DEFAULT = 1
Const CSIDL_LOCAL_APPDATA = &H1C
'Private Const CSIDL_APPDATA = &H1A
'Private Const CSIDL_COMMON_APPDATA = &H23
Private Const CSIDL_PROGRAM_FILES = &H26
Private Const CSIDL_PROGRAM_FILES_COMMON = &H2B
Private Const CSIDL_PROGRAM_FILES_COMMONX86 = &H2C


Private Type MemoryStatus
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Type SYSTEM_INFO
    dwOemID As Long
    dwPageSize As Long
    lpMinimumApplicationAddress As Long
    lpMaximumApplicationAddress As Long
    dwActiveProcessorMask As Long
    dwNumberOfProcessors As Long
    dwProcessorType As Long
    dwAllocationGranularity As Long
    wProcessorLevel As Integer
    wProcessorRevision As Integer
End Type
Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersion As Long
    dwFileVersionMS As Long
    dwFileVersionLS As Long
    dwProductVersionMS As Long
    dwProductVersionLS As Long
    dwFileFlagsMask As Long
    dwFileFlags As Long
    dwFileOS As Long
    dwFileType As Long
    dwFileSubtype As Long
    dwFileDateMS As Long
    dwFileDateLS As Long
End Type

Private tpMemoria   As MemoryStatus
Private sOS         As String
    
    
    Public Enum EnumRegistryRootKeys
  rrkHKeyClassesRoot = &H80000000
  rrkHKeyCurrentUser = &H80000001
  rrkHKeyLocalMachine = &H80000002
  rrkHKeyUsers = &H80000003
End Enum

Public Enum EnumRegistryValueType
  rrkRegSZ = 1
  rrkregBinary = 3
  rrkregdword = 4
End Enum

Private Const mcregOptionNonVolatile = 0

Private Const mcregErrorNone = 0
Private Const mcregErrorBadDB = 1
Private Const mcregErrorBadKey = 2
Private Const mcregErrorCantOpen = 3
Private Const mcregErrorCantRead = 4
Private Const mcregErrorCantWrite = 5
Private Const mcregErrorOutOfMemory = 6
Private Const mcregErrorInvalidParameter = 7
Private Const mcregErrorAccessDenied = 8
Private Const mcregErrorInvalidParameterS = 87
Private Const mcregErrorNoMoreItems = 259

Private Const mcregKeyAllAccess = &H3F
Private Const mcregKeyQueryValue = &H1
    
    
'==================
' Private Declares
'==================
Private Declare Function GetComputerName Lib "KERNEL32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "KERNEL32" Alias "GetDiskFreeSpaceExA" (ByVal lpszDirectory As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Boolean
Private Declare Function GetDriveType Lib "KERNEL32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function GetLocaleInfo Lib "KERNEL32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Private Declare Function GetLogicalDriveStrings Lib "KERNEL32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Integer) As Integer
Private Declare Function GetUserDefaultLCID Lib "KERNEL32" () As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetVersionEx Lib "KERNEL32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function GetWindowsDirectory Lib "KERNEL32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32.dll" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Sub GetSystemInfo Lib "KERNEL32" (lpSystemInfo As SYSTEM_INFO)
Private Declare Sub GlobalMemoryStatus Lib "KERNEL32" (lpBuffer As MemoryStatus)
'Para obtener la versin de un fichero:
Private Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "version.dll" Alias "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, lplpBuffer As Long, puLen As Long) As Long
Private Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" (ByVal lpString1 As Any, ByVal lpString2 As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Declare Function SHGetFolderPath Lib "shell32.dll" Alias "SHGetFolderPathA" (ByVal hwndOwner As Long, ByVal nFolder As Long, ByVal hToken As Long, ByVal dwFlags As Long, ByVal lpszPath As String) As Long

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type
Private Declare Function RegCloseKey _
  Lib "advapi32.dll" _
  (ByVal lngHKey As Long) _
  As Long

Private Declare Function RegCreateKeyEx _
  Lib "advapi32.dll" _
  Alias "RegCreateKeyExA" _
  (ByVal lngHKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    ByVal lpSecurityAttributes As Long, _
    phkResult As Long, _
    lpdwDisposition As Long) _
  As Long

Private Declare Function RegOpenKeyEx _
  Lib "advapi32.dll" _
  Alias "RegOpenKeyExA" _
  (ByVal lngHKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) _
  As Long

Private Declare Function RegQueryValueExString _
  Lib "advapi32.dll" _
  Alias "RegQueryValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As String, _
    lpcbData As Long) _
  As Long

Private Declare Function RegQueryValueExLong _
  Lib "advapi32.dll" _
  Alias "RegQueryValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Long, _
    lpcbData As Long) _
  As Long

Private Declare Function RegQueryValueExBinary _
  Lib "advapi32.dll" _
  Alias "RegQueryValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) _
  As Long
  
Private Declare Function RegQueryValueExNULL _
  Lib "advapi32.dll" _
  Alias "RegQueryValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) _
  As Long

Private Declare Function RegSetValueExString _
  Lib "advapi32.dll" _
  Alias "RegSetValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    ByVal lpValue As String, _
    ByVal cbData As Long) _
  As Long

Private Declare Function RegSetValueExLong _
  Lib "advapi32.dll" _
  Alias "RegSetValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpValue As Long, _
    ByVal cbData As Long) _
  As Long

Private Declare Function RegSetValueExBinary _
  Lib "advapi32.dll" _
  Alias "RegSetValueExA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    ByVal lpValue As Long, _
    ByVal cbData As Long) _
  As Long
  
Private Declare Function RegEnumKey _
  Lib "advapi32.dll" _
  Alias "RegEnumKeyA" _
  (ByVal lngHKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    ByVal cbName As Long) _
  As Long

Private Declare Function RegQueryInfoKey _
  Lib "advapi32.dll" _
  Alias "RegQueryInfoKeyA" _
  (ByVal lngHKey As Long, _
    ByVal lpClass As String, _
    ByVal lpcbClass As Long, _
    ByVal lpReserved As Long, _
    lpcSubKeys As Long, _
    lpcbMaxSubKeyLen As Long, _
    ByVal lpcbMaxClassLen As Long, _
    lpcValues As Long, _
    lpcbMaxValueNameLen As Long, _
    ByVal lpcbMaxValueLen As Long, _
    ByVal lpcbSecurityDescriptor As Long, _
    lpftLastWriteTime As FILETIME) _
  As Long

Private Declare Function RegEnumValue _
  Lib "advapi32.dll" _
  Alias "RegEnumValueA" _
  (ByVal lngHKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpValueName As String, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpType As Long, _
    ByVal lpData As Byte, _
    ByVal lpcbData As Long) _
  As Long

Private Declare Function RegDeleteKey _
  Lib "advapi32.dll" _
  Alias "RegDeleteKeyA" _
  (ByVal lngHKey As Long, _
    ByVal lpSubKey As String) _
  As Long

Private Declare Function RegDeleteValue _
  Lib "advapi32.dll" _
  Alias "RegDeleteValueA" _
  (ByVal lngHKey As Long, _
    ByVal lpValueName As String) _
  As Long


Function SystemInfo() As String
'Esta funcin  resume en una nica cadena completamente todas las
'distintas funciones o caracteristicas calculadas en este mdulo.
'Es llamada desde MandaEMailCompleto
Dim arrMemoria As Variant, impr As Printer, sSystemState As String, strTemp As String
On Error Resume Next
1540 Screen.MousePointer = vbHourglass
1550 DoEvents

1570 sSystemState = ""
1580 sSystemState = sSystemState & vbCrLf
1590 sSystemState = sSystemState & " ====================================" & vbCrLf
1600 sSystemState = sSystemState & "      Informe Sistema   " & Date & vbCrLf
1610 sSystemState = sSystemState & " ====================================" & vbCrLf
1620 sSystemState = sSystemState & vbCrLf
'General
1640 sSystemState = sSystemState & "General" & vbCrLf
1650 sSystemState = sSystemState & "=======" & vbCrLf

  'ComputerName
1680 sSystemState = sSystemState & "   Nombre del Ordenador........" & NombreMaquina() & vbCrLf

'App Title
1710 sSystemState = sSystemState & "   App.Title..................." & VB.App.Title & vbCrLf

'Path
1740 sSystemState = sSystemState & "   App.Path...................." & VB.App.Path & vbCrLf

'Version
1770 sSystemState = sSystemState & "   App.Version................." & VB.App.Major & "." & VB.App.Minor & "." & VB.App.Revision & vbCrLf

'Other Instances
1800 sSystemState = sSystemState & "   Instancias Previas.........." & VB.App.PrevInstance & vbCrLf

'Exe information

1840 sSystemState = sSystemState + "   EXEName..................." & VB.App.EXEName & vbCrLf
'   Exe Time Stamp
1860 sSystemState = sSystemState + "   EXE modificado el ............" & FileDateTime(VB.App.Path + "\" + VB.App.EXEName + ".exe") & vbCrLf
'   Exe Size
1880 sSystemState = sSystemState + "   Tamao EXE................" & Format$(FileLen(VB.App.Path + "\" + VB.App.EXEName + ".exe"), "###,###,###") & " bytes" & vbCrLf & vbCrLf

'OS Info
1910 sSystemState = sSystemState & vbCrLf
1920 sSystemState = sSystemState & "Sistema Operativo " & vbCrLf
1930 sSystemState = sSystemState & "=================" & vbCrLf

'...Windows Version
1960 sSystemState = sSystemState & "   Version Windows....." & SysOSInfo() & vbCrLf

'...Windows Dir
1990 sSystemState = sSystemState & "   Directorio Windows ..." & SysWindowsDir & vbCrLf

'System Dir
2020 sSystemState = sSystemState & "   Directorio 'System' ..." & SystemDir & vbCrLf

'Archivos de programa
2050 sSystemState = sSystemState & "   Directorio 'Program Files' ..." & ProgramFilesDir & vbCrLf

'Archivos comunes (Common Files)
2080 sSystemState = sSystemState & "   Directorio 'Common Files' ..." & CommonDir & vbCrLf

'...Current Path
2110 sSystemState = sSystemState & "   CurDir........" & CurDir() & vbCrLf

'DataAccess
2140 sSystemState = sSystemState & vbCrLf
2150 sSystemState = sSystemState & "Acceso a Datos " & vbCrLf
2160 sSystemState = sSystemState & "=================" & vbCrLf

'Versin de MDAC (la que aparece en el registro)
2190 strTemp = versionMDAC
2200 If Len(strTemp) = 0 Then
2210     strTemp = "    No existe el valor HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\DataAccess\FullInstallVer"
2220 End If
2230 sSystemState = sSystemState & "   Version MDAC....." & strTemp & vbCrLf

'... ADO
2260 strTemp = versionADO
2270 If Len(strTemp) = 0 Then
2280     strTemp = "    No se encuentra informacin sobre dlls de ado"
2290 End If
2300 sSystemState = sSystemState & "   Version ADO....." & strTemp & vbCrLf

'... Jet40
2330 strTemp = verJet40
2340 If Len(strTemp) = 0 Then
2350     strTemp = "    No se encuentra informacin para msjet40.dll o msjetoledb40.dll"
2360 End If
2370 sSystemState = sSystemState & "   Version Jet40....." & strTemp & vbCrLf

'Configuraciones locales
2400 sSystemState = sSystemState & vbCrLf
2410 sSystemState = sSystemState & "Configuraciones locales" & vbCrLf
2420 sSystemState = sSystemState & "=======================" & vbCrLf

'...Language
2450 sSystemState = sSystemState + "   Lenguaje..............     " & SysLanguage() & vbCrLf
'...Pais
2470 sSystemState = sSystemState + "   Pais......................     " & SysCountry() & vbCrLf
'...Separador de fecha
2490 sSystemState = sSystemState + "   Separador de fecha   " & SeparadorFecha() & vbCrLf
'...Separador HH:MM
2510 sSystemState = sSystemState + "   Separador de tiempo      " & SeparadorHorasMinutos() & vbCrLf
'...Formato LongDate
2530 sSystemState = sSystemState + "   Formato LongDate   " & FormatoLongDate() & vbCrLf
'...Formato ShortDate
2550 sSystemState = sSystemState + "   Formato ShortDate   " & FormatoShortDate() & vbCrLf
'...Formato Time
2570 sSystemState = sSystemState + "   Formato tiempo        " & TimeFormat() & vbCrLf
'...Separador decimal
2590 sSystemState = sSystemState + "   Separador decimal   " & SeparadorDecimal() & vbCrLf
'...MidEastern Language
2610 sSystemState = sSystemState & "   MidEast............." & SysMidEastEnabled() & vbCrLf
'...DBCS
2630 sSystemState = sSystemState & "   DCBS................" & SysDBCSEnabled() & vbCrLf

'Memory
2660 sSystemState = sSystemState & vbCrLf
2670 sSystemState = sSystemState & "Memoria" & vbCrLf
2680 sSystemState = sSystemState & "=======" & vbCrLf

2700 arrMemoria = SysMemory
'...Total Physical
2720 sSystemState = sSystemState & "   Memoria fisica total.........." & arrMemoria(0) & vbCrLf
'...Available Physical
2740 sSystemState = sSystemState & "   Memoria fisica disponible....." & arrMemoria(1) & vbCrLf

'...Virtual Memory
2770 sSystemState = sSystemState & "   Memoria virtual..............." & arrMemoria(2) & vbCrLf
'...Virtual disponible
2790 sSystemState = sSystemState & "   Memoria virtual disponible...." & arrMemoria(3) & vbCrLf

'Processor
2820 sSystemState = sSystemState & vbCrLf
2830 sSystemState = sSystemState + "Procesador" & vbCrLf
2840 sSystemState = sSystemState & "==========" & vbCrLf

'...CPU Type
2870 sSystemState = sSystemState & "   CPU................." & SysCPUInfo() & vbCrLf
'...Number of CPUs
2890 sSystemState = sSystemState & "   Nmero de CPUs......" & SysNumCPUs() & vbCrLf

'Drives
2920 sSystemState = sSystemState & vbCrLf
2930 sSystemState = sSystemState + "Drives" & vbCrLf
2940 sSystemState = sSystemState & "======" & vbCrLf
2950 Call SysGetDrives(sSystemState)

2970 sSystemState = sSystemState & vbCrLf
2980 sSystemState = sSystemState & "Impresora por defecto" & vbCrLf
2990 sSystemState = sSystemState & "=====================" & vbCrLf

3010 With Printer
3020 sSystemState = sSystemState & "   DeviceName..........." & .DeviceName & vbCrLf
3030 sSystemState = sSystemState & "   DriverName..........." & .DriverName & vbCrLf
3040 sSystemState = sSystemState & "   PaperSize................" & .PaperSize & vbCrLf
3050 sSystemState = sSystemState & "   Orientation..........." & .Orientation & vbCrLf
3060 sSystemState = sSystemState & "   ColorMode............" & .ColorMode & vbCrLf
3070 sSystemState = sSystemState & "   Duplex..............." & .Duplex & vbCrLf
3080 sSystemState = sSystemState & "   Zoom..................." & .Zoom & vbCrLf
3090 sSystemState = sSystemState & "   FontName............." & .FontName & vbCrLf
3100 sSystemState = sSystemState & "   FontSize............." & .FontSize & vbCrLf
3110 sSystemState = sSystemState & "   Height..............." & .Height & vbCrLf
3120 sSystemState = sSystemState & "   ScaleHeight..........." & .ScaleHeight & vbCrLf
3130 sSystemState = sSystemState & "   Width................" & .Width & vbCrLf
3140 sSystemState = sSystemState & "   ScaleWidth..........." & .ScaleWidth & vbCrLf
3150 sSystemState = sSystemState & "   Scalemode............." & .ScaleMode & vbCrLf
3160 sSystemState = sSystemState & "   TextWidth('Hola')...." & .TextWidth("Hola") & vbCrLf
3170 sSystemState = sSystemState & "   TextHeight('X')...." & .TextHeight("X") & vbCrLf
3180 End With

'Display Information
3210 sSystemState = sSystemState & vbCrLf
3220 sSystemState = sSystemState & "Informacin Video" & vbCrLf
3230 sSystemState = sSystemState & "=================" & vbCrLf

'...Colors
3260 sSystemState = sSystemState & "   Colores......................." & Format$(SysColorPalette(), "###,###,###") & vbCrLf
'...Screen size
3280 sSystemState = sSystemState & "   Resolucion pantalla..........." & SysDisplayRes() & vbCrLf
'...Number of Monitors
3300 sSystemState = sSystemState & "   Numero de monitores..........." & SysNumMonitors() & vbCrLf

'Mouse
3330 sSystemState = sSystemState & vbCrLf
3340 sSystemState = sSystemState & "Ratn" & vbCrLf
3350 sSystemState = sSystemState & "=====" & vbCrLf

'...Mouse present
3380 sSystemState = sSystemState + "   Hay raton......." & IIf(GetSystemMetrics(SM_MOUSEPRESENT), "Yes", "No") & vbCrLf

'...Num Mouse Buttons
3410 sSystemState = sSystemState + "   N botones raton......." & SysNumMouseButtons() & vbCrLf
'...HasMouseWheel
3430 sSystemState = sSystemState + "   Rueda en el raton......." & SysHasMouseWheel() & vbCrLf
'Aqau se podra incluir informacin sobre el proyecto particular: valor de las variables globales, formularios cargados, etc
3440 SystemInfo = sSystemState

3460 Screen.MousePointer = vbDefault
End Function

Public Sub SysGetDrives(ByRef sSystemState As String)
  'Gets the drives available to the system
On Error Resume Next
    
  Dim sBuffer As String * 128
  Dim lretval As Long

  'Drives
  Dim nNumDrives As Integer
3660   nNumDrives = GetLogicalDriveStrings(Len(sBuffer), sBuffer)
  '   Floppies
  Dim nFloppies As Integer
3690   If UCase$(Left$(sBuffer, 3)) = "A:\" Then nFloppies = 1
3700   If UCase$(Mid$(sBuffer, 5, 3)) = "B:\" Then nFloppies = nFloppies + 1
3710   sSystemState = sSystemState + "   Floppies............" & nFloppies & vbCrLf
3720   sSystemState = sSystemState + "   Disks..............." & (nNumDrives / 4) - nFloppies & vbCrLf 'Each drive is "d:\" plus null
  '   Enum of drives and Free space
  Dim lpFreeBytesAvailToCaller As Currency
  Dim lpTotalBytes As Currency
  Dim lpTotalFreeBytes As Currency
  Dim lpBuffer As String
  Dim nIndex As Integer

3800   For nIndex = 0 To (25)
3810     lpBuffer = Chr$(65 + nIndex) + ":"
    Select Case GetDriveType(Chr$(65 + nIndex) + ":\")
      Case DRIVE_UNKNOWN
3840         sSystemState = sSystemState + "   Drive " & lpBuffer & "...........Unknown   " & vbCrLf
      Case DRIVE_NO_ROOT_DIR
      Case DRIVE_REMOVABLE
3870         sSystemState = sSystemState + "   Drive " & lpBuffer & "...........Floppy    " & vbCrLf
      Case DRIVE_FIXED
3890         lretval = GetDiskFreeSpaceEx(lpBuffer, lpFreeBytesAvailToCaller, lpTotalBytes, lpTotalFreeBytes)
3900         sSystemState = sSystemState + "   Drive " & lpBuffer & "...........Fixed     " & Format$(lpFreeBytesAvailToCaller * 10, "###,###,###") & " KB Free" & vbCrLf
      Case DRIVE_REMOTE
        'user can enable the following line with possible consequence of a significant hit to performance
        'lRetval = GetDiskFreeSpaceEx(lpBuffer, lpFreeBytesAvailToCaller, lpTotalBytes, lpTotalFreeBytes)
3940         sSystemState = sSystemState + "   Drive " & lpBuffer & "...........Network   " & vbCrLf ' & Format$(lpFreeBytesAvailToCaller * 10, "###,###,###") & " KB Free" & vbCrLf
      Case DRIVE_CDROM
3960         sSystemState = sSystemState + "   Drive " & lpBuffer & "...........CD        " & vbCrLf
    End Select
3980   Next

End Sub

Function SysColorPalette() As String
  Dim lDC As Long
  Dim lHwnd As Long
  Dim sTmp As String
  Dim lTotalBits As Long
  
  On Error GoTo ERR_HANDLER

4100   lHwnd = GetDesktopWindow()
4110   If (lHwnd <> 0) Then
4120     lDC = GetDC(lHwnd)
4130     If (lDC) Then
4140       lTotalBits = (GetDeviceCaps(lDC, BITSPIXEL) * GetDeviceCaps(lDC, PLANES))
4150       If (lTotalBits = 24) Then
4160         sTmp = "True Color"
4170       Else
4180         sTmp = 2 ^ CLng(lTotalBits)
4190       End If
4200       Call ReleaseDC(lHwnd, lDC)
4210     End If
4220   End If

4240   SysColorPalette = sTmp

4260   Exit Function
ERR_HANDLER:
4280   SysColorPalette = ""
End Function

Function NombreMaquina() As String
  'Gets the name of the machine
4360   Const MAXSIZE As Integer = 256
  Dim sTmp As String * MAXSIZE
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

4420   lLen = MAXSIZE - 1
4430   If (GetComputerName(sTmp, lLen)) Then
4440     NombreMaquina = Left$(sTmp, lLen)
4450   Else
4460     NombreMaquina = ""
4470   End If

4490   Exit Function
ERR_HANDLER:
4510   NombreMaquina = ""
End Function

Function SysCountry() As String
  'Gets the Country from the locale info
4530   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

4600   lLCID = GetUserDefaultLCID()
4610   If (lLCID <> 0) Then
4620     lLen = GetLocaleInfo(lLCID, LOCALE_SNATIVECTRYNAME, sTmp, MAXSIZE - 1)
4630     If (lLen) Then
4640       SysCountry = Left$(sTmp, lLen - 1)
4650     End If
4660   End If

4680   Exit Function
ERR_HANDLER:
4700   SysCountry = ""
End Function

Function SysCPUInfo() As String
  On Error GoTo ERR_HANDLER
  'Gets information about the CPU
  Dim SYSINFO As SYSTEM_INFO
    
  Dim strModel As String
  Dim strStepping As String
  Dim strTemp As String
  
4820   Call GetSystemInfo(SYSINFO)

  Select Case SYSINFO.dwProcessorType
    Case PROCESSOR_INTEL_386
4860       SysCPUInfo = "Intel 386"
    Case PROCESSOR_INTEL_486
4880       SysCPUInfo = "Intel 386"
    Case PROCESSOR_INTEL_PENTIUM
      'Check which version
4910       If SYSINFO.wProcessorLevel = 6 Then
4920         strTemp = Hex(SYSINFO.wProcessorRevision)
4930         Do While Len(strTemp) < 4
4940           strTemp = "0" & strTemp
4950         Loop
        'First int of Hex(SystemInfo.wProcessorRevision) is model #
4970         strModel = Left$(strTemp, 2)
        'Third int of Hex(SystemInfo.wProcessorRevision) is stepping #
4990         strStepping = Mid$(strTemp, 3, 2)
        Select Case Val(strModel) 'Check model number
          Case 1
5020             SysCPUInfo = "Intel Pentium Pro, Model " & strModel & ", Stepping " & strStepping
          Case 3
5040             SysCPUInfo = "Intel Pentium II, Model 3" & " Stepping " & strStepping
          Case 5
5060             SysCPUInfo = "Intel Pentium II Model 5, Pentium II Xeon Model 5, or Celeron Model 5," & " Stepping " & strStepping
          Case 6
5080             SysCPUInfo = "Intel Celeron Model 6" & " Stepping, " & strStepping
          Case 7 To 8
5100             SysCPUInfo = "Intel Pentium III or Pentium III Xeon Model, " & strModel & " Stepping " & strStepping
          Case Else
5120             SysCPUInfo = "Unable to determine processor type"
        End Select
        'end fix
5150       Else
5160         SysCPUInfo = "Pentium"
5170       End If
    Case PROCESSOR_MIPS_R4000
5190       SysCPUInfo = "MIPS R4000"
    Case PROCESSOR_ALPHA_21064
5210       SysCPUInfo = "Alpha 21064"
    Case Else
5230       SysCPUInfo = "Unknown"
  End Select
5250   Exit Function
ERR_HANDLER:
5270   SysCPUInfo = ""
End Function

Function SysDBCSEnabled() As String
  On Error GoTo ERR_HANDLER
5320   If (GetSystemMetrics(SM_DBCSENABLED)) Then
5330     SysDBCSEnabled = "Yes"
5340   Else
5350     SysDBCSEnabled = "No"
5360   End If
5370   Exit Function
ERR_HANDLER:
5390   SysDBCSEnabled = ""
End Function

Function SysMidEastEnabled() As String
  'Returns whether the user has Mideast enabled
  On Error GoTo ERR_HANDLER

5460   If (GetSystemMetrics(SM_MIDEASTENABLED)) Then
5470     SysMidEastEnabled = "Yes"
5480   Else
5490     SysMidEastEnabled = "No"
5500   End If
    
5520   Exit Function
ERR_HANDLER:
5540   SysMidEastEnabled = ""
End Function

Function SysDisplayRes() As String
Dim lDC As Long
Dim lHwnd As Long
Dim sTmp As String
On Error GoTo ERR_HANDLER
5620 lHwnd = GetDesktopWindow()
5630 If (lHwnd) Then
5640   lDC = GetDC(lHwnd)
5650   If (lDC) Then
5660     sTmp = GetDeviceCaps(lDC, HORZRES) & " x " & GetDeviceCaps(lDC, VERTRES)
5670     Call ReleaseDC(lHwnd, lDC)
5680   End If
5690 End If
5700 SysDisplayRes = sTmp
5710 Exit Function
ERR_HANDLER:
5730   SysDisplayRes = ""
End Function
Function SysHasMouseWheel() As String
'Does the user have a MouseWheel enabled

On Error GoTo ERR_HANDLER

5800 If (GetSystemMetrics(SM_MOUSEWHEELPRESENT)) Then
5810   SysHasMouseWheel = "Yes"
5820 Else
5830   SysHasMouseWheel = "No"
5840 End If
  
5860 Exit Function
ERR_HANDLER:
5880 SysHasMouseWheel = ""
End Function

Function SysLanguage() As String

5930 Const MAXSIZE As Integer = 100
Dim sTmp As String * MAXSIZE
Dim lLCID As Long
Dim lLen As Long

On Error GoTo ERR_HANDLER

6000 lLCID = GetUserDefaultLCID()
6010 If (lLCID <> 0) Then
6020   lLen = GetLocaleInfo(lLCID, LOCALE_SNATIVELANGNAME, sTmp, MAXSIZE - 1)
6030   If (lLen) Then
6040     SysLanguage = Left$(sTmp, lLen - 1)
6050   End If
6060 End If

6080   Exit Function
ERR_HANDLER:
6100   SysLanguage = ""
End Function

Function SysNumCPUs() As String
'Nmero de CPUs
Dim SYSINFO As SYSTEM_INFO
On Error GoTo ERR_HANDLER
6170 Call GetSystemInfo(SYSINFO)
6180 SysNumCPUs = SYSINFO.dwNumberOfProcessors
6190 Exit Function
ERR_HANDLER:
6210   SysNumCPUs = ""
End Function

Function SysNumMonitors() As String
  'Gets the number of Monitors
  Dim lNum As Long

  On Error GoTo ERR_HANDLER

6300   lNum = GetSystemMetrics(SM_CMONITORS)
6310   If (lNum > 0) Then
6320     SysNumMonitors = lNum
6330   Else
6340     SysNumMonitors = 1
6350   End If
    
6370   Exit Function
ERR_HANDLER:
6390   SysNumMonitors = ""
End Function

Function SysNumMouseButtons() As String
  'Gets the number of MouseButtons

  On Error GoTo ERR_HANDLER

6470   SysNumMouseButtons = GetSystemMetrics(SM_CMOUSEBUTTONS)

6490   Exit Function
ERR_HANDLER:
6510   SysNumMouseButtons = ""
End Function

Function SysOSInfo() As String
'Gets the version of the OS
Dim OSVerInfo As OSVERSIONINFO
Dim sTmp As String
Dim sSPInfo As String
Dim lPos As Long

On Error GoTo ERR_HANDLER

'Set the size of the structure
6640 OSVerInfo.dwOSVersionInfoSize = 148
6650 OSVerInfo.szCSDVersion = String$(128, "*")

6670 If (GetVersionEx(OSVerInfo)) Then
  '...Get the ServicePack version
6690   lPos = InStr(1, OSVerInfo.szCSDVersion, Chr$(0)) - 1
6700   If (lPos) Then
6710     sSPInfo = Left$(OSVerInfo.szCSDVersion, lPos)
6720   End If
      
6740   If (OSVerInfo.dwPlatformId = VER_PLATFORM_WIN32_NT) Then
    'Windows NT3.51, NT4.0, 2000, XP
6760       If OSVerInfo.dwMajorVersion = 3 Then
6770           sTmp = "Windows NT 3.51 "
6780       ElseIf OSVerInfo.dwMajorVersion = 4 Then
6790           sTmp = "Windows NT 4.0 "
6800       ElseIf OSVerInfo.dwMajorVersion = 5 Then
6810           If OSVerInfo.dwMinorVersion = 0 Then
6820               sTmp = "Windows 2000"
6830           ElseIf OSVerInfo.dwMinorVersion = 1 Then
6840               sTmp = "Windows XP"
6850           ElseIf OSVerInfo.dwMinorVersion = 1 Then
6860               sTmp = "Windows 2003 Server"
6870           Else
6880               sTmp = "Windows NT, versin desconocida"
6890           End If
6900       Else
6910           sTmp = "Windows NT, versin desconocida"
6920       End If
6930   ElseIf (OSVerInfo.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) Then
6940       If OSVerInfo.dwMajorVersion = 6 Then
6950               sTmp = "Windows Longhorn"
6960       ElseIf OSVerInfo.dwMajorVersion = 5 Then
6970               sTmp = "Windows ME"
6980       ElseIf OSVerInfo.dwMajorVersion = 4 Then
          Select Case OSVerInfo.dwMinorVersion
          Case 0
7010           sTmp = "Windows 95"
          Case 10
7030           sTmp = "Windows 98"
7040           If OSVerInfo.szCSDVersion = "C" Or OSVerInfo.szCSDVersion = "B" Then
7050             sTmp = sTmp & " SE"
7060           End If
          Case 90
7080           sTmp = "Windows ME"
          Case Else
7100           sTmp = "Windows, versin desconocida"
          End Select
7120       ElseIf OSVerInfo.dwMajorVersion < 4 Then
7130           sTmp = "Windows 95 o menor"
7140       Else
7150           sTmp = "Windows, versin desconocida"
7160       End If
7170   Else 'Unknown OS
7180     sTmp = "Windows, versin desconocida"
7190   End If
7200   sTmp = sTmp & " (" & OSVerInfo.dwPlatformId & "." & OSVerInfo.dwMajorVersion & "." & OSVerInfo.dwMinorVersion & " Build: " & OSVerInfo.dwBuildNumber & ") -" & sSPInfo
7210 Else
7220 SysOSInfo = ""
7230 End If
7240 SysOSInfo = sTmp
7250 Exit Function
ERR_HANDLER:
7270   SysOSInfo = ""
End Function

Function SysPhysicalMem() As String
  'Gets the total physical memory
  Dim MemStatus As MemoryStatus
  Dim lResult As Currency

  On Error GoTo ERR_HANDLER

7370   Call GlobalMemoryStatus(MemStatus)

7390   lResult = MemStatus.dwTotalPhys + (CLng(1024) * CLng(1024)) - 1
7400   lResult = (lResult) \ ((CLng(1024) * CLng(1024)))
7410   SysPhysicalMem = lResult

7430   Exit Function
ERR_HANDLER:
7450   SysPhysicalMem = ""
End Function

Function SysUserName() As String
  'Gets the current User on the remote machine
7420   Const MAXSIZE As Integer = 256
  Dim sTmp As String * MAXSIZE
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

7480   lLen = MAXSIZE - 1
7490   If (GetUserName(sTmp, lLen)) Then
7500     SysUserName = Left$(sTmp, lLen - 1)
7510   Else
7520     SysUserName = ""
7530   End If

7550   Exit Function
ERR_HANDLER:
7570   SysUserName = ""
End Function
Function SysWindowsDir() As String
'Gets the current User on the remote machine
7610 Const MAXSIZE As Integer = 255
Dim sTmp As String * MAXSIZE
Dim lretval As Long
On Error GoTo ERR_HANDLER
7650 sTmp = Space$(MAXSIZE)
7660 lretval = GetWindowsDirectory(sTmp, MAXSIZE)
7670 SysWindowsDir = Left$(sTmp, lretval)
7680 Exit Function
ERR_HANDLER:
7700   SysWindowsDir = ""
End Function

Function SystemDir() As String
'Gets the current User on the remote machine
7850 Const MAXSIZE As Integer = 255
Dim sTmp As String * MAXSIZE
Dim lretval As Long
On Error GoTo ERR_HANDLER
7890 sTmp = Space$(MAXSIZE)
7900 lretval = GetSystemDirectory(sTmp, MAXSIZE)
7910 SystemDir = Left$(sTmp, lretval)
7920 Exit Function
ERR_HANDLER:
7940   SystemDir = ""
End Function
Function versionMDAC() As String
'Pte
'Calcula la versin de MDAC (aproximadamente, pues solo calcula el
'valor en HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\DataAccess\FullInstallVer
On Error GoTo ERR_HANDLER
7910 versionMDAC = RegistryGetKeyValue(rrkHKeyLocalMachine, "Software\Microsoft\DataAccess", "FullInstallVer")
7920 Exit Function
ERR_HANDLER:
7940   versionMDAC = ""
End Function
Function versionADO() As String
'Mira si encuentra los archivos msado15.dll, msadox.dll y msjro.dll en Common Files

Dim msado15 As String, msadox As String, msjro As String, strTmp As String
On Error GoTo ERR_HANDLER
'busca msado15.dll
8020 msado15 = Version(CommonDir & "\System\ado\msado15.dll")
'busca msadox.dll
8040 msadox = Version(CommonDir & "\System\ado\msadox.dll")
'busca msjro.dll
8060 msjro = Version(CommonDir & "\System\ado\msjro.dll")

8080 If Len(msado15 & msadox & msjro) = 0 Then  'No parecen existir las dll de ADO
8090     versionADO = ""
8100     Exit Function
8110 End If
On Error Resume Next
8130 msado15 = Left(msado15, InStr(3, msado15, ".") - 1)
8140 If Len(msado15) > 0 Then
8150 msado15 = msado15 & " (msado15.dll) ; "
8160 End If
8170 msadox = Left(msadox, InStr(3, msadox, ".") - 1)
8180 If Len(msadox) > 0 Then
8190 msadox = msadox & " (msadox.dll) ; "
8200 End If
8210 msjro = Left(msjro, InStr(3, msjro, ".") - 1)
8220 If Len(msjro) > 0 Then
8230 msjro = msjro & " (msjro.dll)"
8240 End If
8250 versionADO = msado15 & msadox & msjro
8260 Exit Function
ERR_HANDLER:
8280   versionADO = ""
End Function
Function verJet40() As String
Dim strJet40 As String, strJetoledb40 As String, strTmp As String
On Error GoTo ERR_HANDLER
'busca msjet40.dll (en directorio System)
8340 strJet40 = Version(SystemDir & "\msjet40.dll")
'busca msjetoldedb40.dll (en directorio System)
8360 strJetoledb40 = Version(SystemDir & "\msjetoledb40.dll")
8370 If Len(strJet40) = 0 Or Len(strJetoledb40) = 0 Then 'No parece existir msjet40 (motor Jet) y msjetoledb40 (Microsoft Ole DB Provider for Jet)
8380     verJet40 = ""
8390     Exit Function
8400 End If
On Error Resume Next
8420 strTmp = Left(strJet40, InStr(3, strJet40, ".") - 1)
8430 If strTmp = Left(strJetoledb40, InStr(3, strJetoledb40, ".") - 1) Then 'Igual principio de las versiones
8440     verJet40 = strJet40
8450 Else 'Si no coinciden la parte primera de las versiones (o no existe msjetoledb40)
8460     verJet40 = strJet40 & "(msjet40.dll) ; " & strJetoledb40 & "(msjetoledb40.dll)"
8470 End If
8480 Exit Function
ERR_HANDLER:
8500   verJet40 = ""
End Function

Function SysMemory() As String()
'SysMemory(0)= Memoria fsica total
'SysMemory(1)= Memoria fsica disponible
'SysMemory(2)= Memoria virtual total
'SysMemory(3)= Memoria virtual disponible
Dim arrResult(0 To 3) As String, ltempval As Long

On Error GoTo ERR_HANDLER

8760 Call GlobalMemoryStatus(tpMemoria)
8770 tpMemoria.dwLength = Len(tpMemoria)
'Total Memoria Fsica
8790 arrResult(0) = Format$(tpMemoria.dwTotalPhys \ 1024, "###,###,###") & "K"
'Memoria fsica disponible
8810 ltempval = tpMemoria.dwAvailPhys / 1024
8820 If ltempval > 0 Then
8830   arrResult(1) = Format$(ltempval, "###,###,###") & "K"
8840 Else
8850   arrResult(1) = "Ninguna"
8860 End If
'Memoria virtual
8880 arrResult(2) = Format$(tpMemoria.dwTotalVirtual \ 1024, "###,###,###") & "K"
'Memoria disponible virtual
8900 arrResult(3) = Format$(tpMemoria.dwAvailVirtual \ 1024, "###,###,###") & "K"
8910 SysMemory = arrResult
8920 Exit Function
ERR_HANDLER:
8940     arrResult(0) = ""
8950     arrResult(1) = ""
8960     arrResult(2) = ""
8970     arrResult(3) = ""
8980     SysMemory = arrResult
End Function
Function SeparadorFecha() As String
  'Obtiene el separador de fecha
9080   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

9150   lLCID = GetUserDefaultLCID()
9160   If (lLCID <> 0) Then
9170     lLen = GetLocaleInfo(lLCID, LOCALE_SDATE, sTmp, MAXSIZE - 1)
9180     If (lLen) Then
9190       SeparadorFecha = Left$(sTmp, lLen - 1)
9200     End If
9210   End If

9230   Exit Function
ERR_HANDLER:
9250   SeparadorFecha = ""
End Function
Function SeparadorHorasMinutos() As String
  'Obtiene el separador de tiempo
9290   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

9360   lLCID = GetUserDefaultLCID()
9370   If (lLCID <> 0) Then
9380     lLen = GetLocaleInfo(lLCID, LOCALE_STIME, sTmp, MAXSIZE - 1)
9390     If (lLen) Then
9400       SeparadorHorasMinutos = Left$(sTmp, lLen - 1)
9410     End If
9420   End If

9440   Exit Function
ERR_HANDLER:
9460   SeparadorHorasMinutos = ""
End Function
Function FormatoLongDate() As String
  'Obtiene la fecha larga en el sistema
9500   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

9570   lLCID = GetUserDefaultLCID()
9580   If (lLCID <> 0) Then
9590     lLen = GetLocaleInfo(lLCID, LOCALE_SLONGDATE, sTmp, MAXSIZE - 1)
9600     If (lLen) Then
9610       FormatoLongDate = Left$(sTmp, lLen - 1)
9620     End If
9630   End If

9650   Exit Function
ERR_HANDLER:
9670   FormatoLongDate = ""
End Function
Function FormatoShortDate() As String
  'Obtiene la fecha larga en el sistema
9710   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

9780   lLCID = GetUserDefaultLCID()
9790   If (lLCID <> 0) Then
9800     lLen = GetLocaleInfo(lLCID, LOCALE_SSHORTDATE, sTmp, MAXSIZE - 1)
9810     If (lLen) Then
9820       FormatoShortDate = Left$(sTmp, lLen - 1)
9830     End If
9840   End If

9860   Exit Function
ERR_HANDLER:
9880   FormatoShortDate = ""
End Function
Function TimeFormat() As String
  'Obtiene la fecha larga en el sistema
9720   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

9790   lLCID = GetUserDefaultLCID()
9800   If (lLCID <> 0) Then
9810     lLen = GetLocaleInfo(lLCID, LOCALE_STIMEFORMAT, sTmp, MAXSIZE - 1)
9820     If (lLen) Then
9830       TimeFormat = Left$(sTmp, lLen - 1)
9840     End If
9850   End If

9870   Exit Function
ERR_HANDLER:
9890   TimeFormat = ""
End Function
Function SeparadorDecimal() As String
  'Obtiene la fecha larga en el sistema
10130   Const MAXSIZE As Integer = 100
  Dim sTmp As String * MAXSIZE
  Dim lLCID As Long
  Dim lLen As Long

  On Error GoTo ERR_HANDLER

10200   lLCID = GetUserDefaultLCID()
10210   If (lLCID <> 0) Then
10220     lLen = GetLocaleInfo(lLCID, LOCALE_SDECIMAL, sTmp, MAXSIZE - 1)
10230     If (lLen) Then
10240       SeparadorDecimal = Left$(sTmp, lLen - 1)
10250     End If
10260   End If

10280   Exit Function
ERR_HANDLER:
10300   SeparadorDecimal = ""
End Function
'Funcin para saber la versin de un ejecutable (dll, exe, etc)
'Si no es un ejecutable devuelve una cadena vaca
Private Function Version(Exe As String) As String
    Dim vffi As VS_FIXEDFILEINFO  ' version info structure
    Dim buffer() As Byte          ' buffer for version info resource
    Dim pData As Long             ' pointer to version info data
    Dim nDataLen As Long          ' length of info pointed at by pData
    Dim cpl(0 To 3) As Byte       ' buffer for code page & language
    Dim cplstr As String          ' 8-digit hex string of cpl
    Dim dispstr As String         ' string used to display version information
    Dim retval As Long            ' generic return value
    
On Error GoTo ERR_HANDLER

' First, get the size of the version info resource.  If this function fails, then Text1
' identifies a file that isn't a 32-bit executable/DLL/etc.
10280 nDataLen = GetFileVersionInfoSize(Exe, pData)
10290 If nDataLen = 0 Then
10300     Version = ""
10310     Exit Function
10320 End If
' Make the buffer large enough to hold the version info resource.
10340 ReDim buffer(0 To nDataLen - 1) As Byte
' Get the version information resource.
10360 retval = GetFileVersionInfo(Exe, 0, nDataLen, buffer(0))
' Get a pointer to a structure that holds a bunch of data.
10380 retval = VerQueryValue(buffer(0), "\", pData, nDataLen)
' Copy that structure into the one we can access.
10400 CopyMemory vffi, ByVal pData, nDataLen
' Display the full version number of the file.
10420 dispstr = Trim(Str(HIWORD(vffi.dwFileVersionMS))) & "." & _
        Trim(Str(LOWORD(vffi.dwFileVersionMS))) & "." & _
        Trim(Str(HIWORD(vffi.dwFileVersionLS))) & "." & _
        Trim(Str(LOWORD(vffi.dwFileVersionLS)))
10460 Version = dispstr
10470 Exit Function
ERR_HANDLER:
10490     Version = ""
End Function
'Funcion para la API GetFileVersionInfo:
Public Function HIWORD(ByVal dwValue As Long) As Long
    Dim hexstr As String
On Error Resume Next
10750     hexstr = Right("00000000" & Hex(dwValue), 8)
10760     HIWORD = CLng("&H" & Left(hexstr, 4))
End Function
'Funcion para la API GetFileVersionInfo
Public Function LOWORD(ByVal dwValue As Long) As Long
    Dim hexstr As String
On Error Resume Next
10820     hexstr = Right("00000000" & Hex(dwValue), 8)
10830     LOWORD = CLng("&H" & Right(hexstr, 4))
End Function

Function CommonDir() As String
'Obtiene la carpeta Archivos Comunes bajo Archivos de programa
On Error GoTo ERR_HANDLER
Dim pathName As String  ' receives the path
Dim retval As Long  ' return value

' Make enough room in the buffer to receive the string.
10930 pathName = Space(260)
' Get the path name of the special folder
10950 retval = SHGetFolderPath(0, CSIDL_PROGRAM_FILES_COMMON, 0, SHGFP_TYPE_CURRENT, pathName)
' Remove the empty space from the string.
10970 pathName = Left(pathName, InStr(pathName, vbNullChar) - 1)
10980 CommonDir = pathName
10990 Exit Function
ERR_HANDLER:
11010   CommonDir = ""
End Function
Function ProgramFilesDir() As String
'Obtiene la carpeta Archivos de programa
On Error GoTo ERR_HANDLER
Dim pathName As String  ' receives the path
Dim retval As Long  ' return value
' Make enough room in the buffer to receive the string.
11090 pathName = Space(260)
' Get the path name of the special folder
11110 retval = SHGetFolderPath(0, CSIDL_PROGRAM_FILES, 0, SHGFP_TYPE_CURRENT, pathName)
' Remove the empty space from the string.
11130 pathName = Left(pathName, InStr(pathName, vbNullChar) - 1)
' Display the result.
11150 ProgramFilesDir = pathName
11160 Exit Function
ERR_HANDLER:
11180   ProgramFilesDir = ""
End Function

'Mdulo necesario para el AddIn ProcErr

'Santiago Oliver
'www.oliware.com
'admin@oliware.com
Function SysInfoRes() As String
'Funcin resumida sobre el sistema
'Es llamada desde MandaEMail
Dim arrMemoria As Variant, impr As Printer, sSystemState As String, strTemp As String
On Error Resume Next
11250 Screen.MousePointer = vbHourglass
11260 DoEvents

11280 sSystemState = ""
11290 sSystemState = sSystemState & vbCrLf
11300 sSystemState = sSystemState & " ====================================" & vbCrLf
11310 sSystemState = sSystemState & "      Informe Sistema   " & Date & vbCrLf
11320 sSystemState = sSystemState & " ====================================" & vbCrLf
11330 sSystemState = sSystemState & vbCrLf
'General
11350 sSystemState = sSystemState & "General" & vbCrLf
11360 sSystemState = sSystemState & "=======" & vbCrLf

'App Title
11390 sSystemState = sSystemState & "   App.Title..................." & VB.App.Title & vbCrLf

'Path
11420 sSystemState = sSystemState & "   App.Path...................." & VB.App.Path & vbCrLf

'Version
11450 sSystemState = sSystemState & "   App.Version................." & VB.App.Major & "." & VB.App.Minor & "." & VB.App.Revision & vbCrLf

'OS Info
11480 sSystemState = sSystemState & vbCrLf
11490 sSystemState = sSystemState & "Sistema Operativo " & vbCrLf
11500 sSystemState = sSystemState & "=================" & vbCrLf

'...Windows Version
11530 sSystemState = sSystemState & "   Version Windows....." & SysOSInfo() & vbCrLf

'DataAccess
11560 sSystemState = sSystemState & vbCrLf
11570 sSystemState = sSystemState & "Acceso a Datos " & vbCrLf
11580 sSystemState = sSystemState & "=================" & vbCrLf

'Versin de MDAC (la que aparece en el registro)
11610 strTemp = versionMDAC
11620 If Len(strTemp) = 0 Then
11630     strTemp = "    No existe el valor HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\DataAccess\FullInstallVer"
11640 End If
11650 sSystemState = sSystemState & "   Version MDAC....." & strTemp & vbCrLf

'... ADO
11680 strTemp = versionADO
11690 If Len(strTemp) = 0 Then
11700     strTemp = "    No se encuentra informacin sobre dlls de ado"
11710 End If
11720 sSystemState = sSystemState & "   Version ADO....." & strTemp & vbCrLf

'... Jet40
11750 strTemp = verJet40
11760 If Len(strTemp) = 0 Then
11770     strTemp = "    No se encuentra informacin para msjet40.dll o msjetoledb40.dll"
11780 End If
11790 sSystemState = sSystemState & "   Version Jet40....." & strTemp & vbCrLf

'Configuraciones locales
11820 sSystemState = sSystemState & vbCrLf
11830 sSystemState = sSystemState & "Configuraciones locales" & vbCrLf
11840 sSystemState = sSystemState & "=======================" & vbCrLf

'...Language
11870 sSystemState = sSystemState + "   Lenguaje..............     " & SysLanguage() & vbCrLf
'...Formato LongDate
11890 sSystemState = sSystemState + "   Formato LongDate   " & FormatoLongDate() & vbCrLf
'...Formato ShortDate
11910 sSystemState = sSystemState + "   Formato ShortDate   " & FormatoShortDate() & vbCrLf
'...Formato Time
11930 sSystemState = sSystemState + "   Formato tiempo        " & TimeFormat() & vbCrLf

11950 sSystemState = sSystemState & vbCrLf
11960 sSystemState = sSystemState & "Impresora por defecto" & vbCrLf
11970 sSystemState = sSystemState & "=====================" & vbCrLf

11990 With Printer
12000 sSystemState = sSystemState & "   PaperSize................" & .PaperSize & vbCrLf
12010 sSystemState = sSystemState & "   FontName............." & .FontName & vbCrLf
12020 sSystemState = sSystemState & "   FontSize............." & .FontSize & vbCrLf
12030 End With

12050 SysInfoRes = sSystemState
12060 Screen.MousePointer = vbDefault
End Function

Public Function RegistryGetKeyValue(eRootKey As EnumRegistryRootKeys, strKeyName As String, strValueName As String) As Variant
  ' Comments  : Returns a value from the system registry
  ' Parameters: eRootKey - The root key
  '             strKeyName - The name of the key
  '             strValueName - The name of the value
  ' Returns   : The data in the registry value
  ' Source    : Total VB SourceBook
  '
  Dim lngRetVal As Long
  Dim lngHKey As Long
  Dim varValue As Variant
  Dim strValueData As String
  Dim abytValueData() As Byte
  Dim lngValueData As Long
  Dim lngValueType As Long
  Dim lngDataSize As Long
  
  On Error GoTo PROC_ERR
  
2250   varValue = Empty
  
2270   lngRetVal = RegOpenKeyEx(eRootKey, strKeyName, 0&, mcregKeyQueryValue, _
    lngHKey)
  
2300   If mcregErrorNone = lngRetVal Then
    
2320     lngRetVal = RegQueryValueExNULL(lngHKey, strValueName, 0&, lngValueType, _
      0&, lngDataSize)
    
2350     If lngRetVal = mcregErrorNone Then
      
      Select Case lngValueType
      
      ' String type

        Case rrkRegSZ:
2420           If lngDataSize > 0 Then
2430             strValueData = String(lngDataSize, 0)
2440             lngRetVal = RegQueryValueExString(lngHKey, strValueName, 0&, _
              lngValueType, strValueData, lngDataSize)
2460             If InStr(strValueData, vbNullChar) > 0 Then
2470               strValueData = Mid$(strValueData, 1, InStr(strValueData, _
                vbNullChar) - 1)
2490             End If
2500           End If
2510           If mcregErrorNone = lngRetVal Then
2520             varValue = Left$(strValueData, lngDataSize)
2530           Else
2540             varValue = Empty
2550           End If
        
        ' Long type
        Case rrkregdword:
2590           lngRetVal = RegQueryValueExLong(lngHKey, strValueName, 0&, _
            lngValueType, lngValueData, lngDataSize)
2610           If mcregErrorNone = lngRetVal Then
2620             varValue = lngValueData
2630           End If
                
        ' Binary type
        Case rrkregBinary
2670           If lngDataSize > 0 Then
2680             ReDim abytValueData(lngDataSize) As Byte
2690             lngRetVal = RegQueryValueExBinary(lngHKey, strValueName, 0&, _
              lngValueType, VarPtr(abytValueData(0)), lngDataSize)
2710           End If
2720           If mcregErrorNone = lngRetVal Then
2730             varValue = abytValueData
2740           Else
2750             varValue = Empty
2760           End If
                
        Case Else
          'No other data types supported
2800           lngRetVal = -1
        
      End Select
      
2840     End If
    
2860     RegCloseKey (lngHKey)
2870   End If
  
  'Return varValue
2900   RegistryGetKeyValue = varValue
PROC_EXIT:
2920   Exit Function

PROC_ERR:
2950   MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "RegistryGetKeyValue"
2970   Resume PROC_EXIT
End Function

Public Sub RegistrySetKeyValue( _
  eRootKey As EnumRegistryRootKeys, _
  strKeyName As String, _
  strValueName As String, _
  varData As Variant, _
  eDataType As EnumRegistryValueType)
  ' Comments  : This procedure sets a key value
  ' Parameters: eRootKey - The root key
  '             strKeyName - The name of the key
  '             strValueName - The name of the value
  '             varData - The data to store in the value
  '             eDataType - The type of data to store in the value
  ' Returns   : Nothing
  ' Source    : Total VB SourceBook 6
  '
  Dim lngRetVal As Long
  Dim lngHKey As Long
  Dim strData As String
  Dim lngData As Long
  Dim abytData() As Byte
    
  On Error GoTo PROC_ERR
  
  ' Open the specified key, if it does not exist then create it
3240   lngRetVal = RegCreateKeyEx(eRootKey, strKeyName, 0&, vbNullString, _
    mcregOptionNonVolatile, mcregKeyAllAccess, 0&, lngHKey, 0&)
  
  ' Determine the data type of the key
  Select Case eDataType
  
  Case rrkRegSZ
3310     strData = varData & vbNullChar
3320     lngRetVal = RegSetValueExString(lngHKey, strValueName, 0&, eDataType, _
      strData, Len(strData))
    
  Case rrkregdword
3360     lngData = varData
3370     lngRetVal = RegSetValueExLong(lngHKey, strValueName, 0&, eDataType, _
      lngData, Len(lngData))
  
  ' Binary type
  Case rrkregBinary
3420     abytData = varData
3430     lngRetVal = RegSetValueExBinary(lngHKey, strValueName, 0&, eDataType, _
      VarPtr(abytData(0)), UBound(abytData) + 1)
  
  End Select
  
3480   RegCloseKey (lngHKey)
    
PROC_EXIT:
3510   Exit Sub

PROC_ERR:
3540   MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "RegistrySetKeyValue"
3560   Resume PROC_EXIT
    
End Sub

'Mdulo necesario para el AddIn ProcErr

'Santiago Oliver
'www.oliware.com
'admin@oliware.com

