VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsErrores"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Clase necesaria para el AddIn ProcErr

'Santiago Oliver
'www.oliware.com
'admin@oliware.com

'clsErrores
'==========
'Provee un manejo de errores que atrapa los errores, sigue la pista a la pila de llamadas de
'los procedimientos, mira donde ocurri el error y sus propiedades (nmero, etc) y registra todo.
'Puede mostrar un MsgBox y/o mandar un email con la informacin del sistema y los errores
'ocurridos. Est basado en una idea mostrada en el programa "Total VB SourceBook"
'de FMS Inc.
'
'Necesita el mdulo InfoSistema.bas (tambin disponible en www.oliware.com)
'
'Gran parte del cdigo en esta clase ha sido realizado a base de cortar y pegar. Aparte he
'terminado un AddIn muy til para incluir el manejador de errores automticamente en todos los
'procedimientos de un proyecto (adems de hacer otras cosas interesantes, como incluir nmeros
'de lnea, buscar qu procedimientos llaman a otro, etc) Este AddIn se llama ProcErr y puedes buscarle en www.oliware.com o haciendo
'una bsqueda con Google por su nombre ProcErr.
'
'Comentarios
'===========
'La clase puede usarse como un manejador de errores global para toda la aplicacin al cual
'llamar desde cada procedimiento elegido. Tambin puede crear multiples objetos-manejadores
'de error para diferentes partes de la aplicacin.
'
'La idea bsica es registrar la entrada en cada procedimiento y cada salida. Si un error ocurre
'en ese procedimiento el objeto clsErrores almacena el actual estado del error y de la pila de
'llamadas y da una oportunidad de responder a ese error con un MsgBox, mandando un email y/o
'registrando los datos con el error en un archivo de texto. existe una pila con procedimientos
'para saber no solamente en qu procedimiento ha ocurrido el error, sino qu procedimientos
'han llamado a se y as hasta mantener un mximo de procedimientos especificado en la
'propiedad MaxProcStackItems.
'
'Declarar el Objeto Variable
'===========================
'Para declarar un solo manejador global para toda la aplicacin habra que declarar una variable
'publica en un modulo estandar. Cuando el programa empiece habra que instanciar la variable
'e inicializar cualquier propiedad deseada.
'
'Ejemplo
'=======
'Public gErr As clsErrores
'
'Sub Main()
'  Set gErr = New clsErrores
'  With gErr
'    .Destination = "C:\MiError.txt"
'    .MsgOnError = True
'  End With
'
'  FrmMain.Show
'
'End Sub
'
'Tambin es posible tener un manejador de errores para cada mdulo o cada procedimiento,
'declarando distintas variables-objeto clsErrores en su interior.
'
'Adjudicar propiedades
'=====================
'AppTitle - Titulo de la aplicacion. Por defecto App.Title
'MsgOnError - Por defecto es una cadena vaca. Si es una cadena vaca no muestra ningn mensaje.
'Si la cadena es igual a "normal" entonces muestra un mensaje estndar con el nmero de error,
'descripcin, lnea y procedimiento donde ha ocurrido. Si no es una cadena vaca y no es igual a
'"normal" entonces el MsgBox mostrar la cadena que contenga esta propiedad.
'MaxProcStackItems - Por defecto vale 20. Este es el nmero de procedimientos que se pueden
'guardar en la pila de llamadas. El objeto clsErrores registra la llamada en la pila de los
'procedimientos en los que se hayan introducido los mtodos Push y Pop.
'Destination.- Cadena conteniendo la trayectoria para el archivo log donde se registran los
'errores sucedidos.Por defecto ser App.Path & "\Errores.log".
'EmailDir.-Direccin de correo electrnica para recibir los mensajes de error enviados desde
'el ordenador donde se cometieron.
'MandaEmailOnError.-Valor boolean para saber si el usuario nos mandar un email con informacin
'sobre la mquina del usuario (en el cuerpo del mensaje)
'LogOnError.-Valor boolean que indica si hay que almacenar o no los errores en el archivo log
'
'Cuando la clase se instancia por primera vez en su evento Initialize se ponen las
'propiedades por defecto de cada propiedad que son:
'MaxProcStackItems = 20
'MsgOnError = "" '(cadena vaca)
'Destination = App.path & "\Errores.log"
'MandaEmailOnError = False
'LogOnError = True
'EmailDir = "" '(cadena vaca)
'
'Estas propiedades no hace falta cambiarlas en la mayor parte de los casos, sobre todo cuando el
'manejador de errores utiliza un objeto global, pues cada vez que se cambie una propiedad,
'sta quedar as puesto que la clase no se vuelve a inicializar.
'
'
'
'Uso de la clase
'===============
'
'Esta clase no es un manejador de errores estricto en el sentido de que sirva para tomar
'decisiones sobre qu hacer con el flujo de ejecucin del cdigo. Ms bien est diseado para
'gestionar automticamente la informacin genrica que se le dar al usuario y el almacenamiento
'de toda la informacin relativa a los errores ocurridos.
'
'Para cada procedimiento en el que deseamos incluir el manejo de errores necesitamos hacer tres
'llamadas a los metodos del objeto creado. El metodo Push con el argumento del nombre del
'procedimiento al entrar a l, el mtodo Pop al salir del procedimiento y el mtodo ManejoError
'cuando ocurra un error.
'
'Una vez declarado un objeto de la clase (por ej:    "Set gErr = New clsErrores")
'1) Utilice Push para grabar el nombre del procedimiento en la pila de llamadas (opcional,
'aunque si se usa Push, deber siempre usar el mtodo Pop)
'
'Private Sub cmdTest_Click()
'  gErr.Push "cmdTest_Click"
'
'2)  Si el procedimiento se termina normalmente el mtodo Pop quita el nombre del
'procedimiento de la pila (opcional, aunque si se usa Pop, deber siempre haber usado
'antes el mtodo Push)
'
'
'Salir:
'  gErr.Pop
'  Exit Sub
'
'Importante (para usuarios del Add-In ProcErr): Exit Sub se usa para no caer en el manejo de errores si no hay
'ningn error. Para que cada vez que salgamos de un procedimiento se ejecute
'el mtodo Pop, al insertar el manipulador de errores ProcErr sustituir
'todas las sentencias, Exit Sub, Exit Function y Exit Property por sus
'equivalentes GoTo Salir. Igualmente al quitar del cdigo el manejador,
'restituir los valores iniciales.'

'3)  Al final colocamos una etiqueta para atrapar el error. Al principio del procedimiento
'usaremos una sentencia On Error Go To para entra en el manejador de errores
'
'On Error GoTo PROC_ERR
'
'4)  En la seccion con la etiqueta PROC_ERR  aadimos una llamada al metodo ManejoError de la clase:
'
'PROC_ERR:
'  gErr.ManejoError
'  Resume Salir
'End Sub
'
'
'Ejemplo tpico:
'
'Private Sub cmdTest_Click()
'On Error GoTo PROC_ERR
'  gErr.Push "cmdTest_Click"
'
'  MsgBox (10 / 0)
'
'Salir:
'  gErr.Pop
'  Exit Sub
'
'PROC_ERR:
'  gErr.ManejoError
'  Resume Salir
'End Sub
'
'
'Los ejemplos mostrados arriba son el mnimo cdigo necesario para usar la clase (aunque
'podriamos ahorrarnos los metodos Push y Pop si no nos importa perder la informacin de los
'procedimientos) Adems existe el mtodo ClearLog que borra la informacin del archivo log
'con los datos sobre todos los errores ocurridos.
'
'Nota:  Para equilibrar las llamadas Push y Pop hay que tener cuidado de no usar Exit Sub o
'Exit Function. Para salir del procedimiento es mejor usar una etiqueta tipo "GoTo Salir:" mejor
'que "Exit Function." As antes de salir ejecutaremos el mtodo Pop
'
'Si queremos algn manejo de error adicional, aparte de lo que hace la clase (que no es ms que registrar
'el error, mandar un email y/o un MsgBox) habremos de hacerlo despus de gErr.ManejoError. Por ejemplo:

'Private Sub cmdTest_Click()
'On Error GoTo PROC_ERR
'  gErr.Push "cmdTest_Click"
'
'  MsgBox (10 / 0)
'
'Salir:
'  gErr.Pop
'  Exit Sub
'
'PROC_ERR:
'  gErr.ManejoError
'   if Err.Number=13 Then
'       ResumeNext
'   Else
'       gErr.Pop
'       Err.Raise Err.number, Err.Source, Err.Description
'   End If
'  Resume Salir
'End Sub

'Fijaos en que antes de la sentencia Err.Raise hay que llamar a gErr.Pop puesto que con Err.Raise
'se saldr inmediatamente del procedimiento.
'
'Propiedades con Informacion del Error
'=====================================
'
'Varias propiedades de solo-lectura son adjudicadas solamente si ha ocurrido un error manejado
'por el objeto de la clase, y sern cero, o cadenas vacas si no han ocurrido errores:
'
'ErrorDescription - Corresponde a Err.Description
'ErrorNumber - Corresponde a Err.Number
'ErrorLine - Corresponde a Erl (lnea donde ha ocurrido el error)
'ProcName - El nombre del procedimiento que se estaba ejecutando cuando ocurri el error
'
'
'
'
'Mtodos, Eventos y Propiedades
'==============================
'Evento Class_Initialize:
'Llama a IniVal, que se encarga de inicializar las propiedades
'Destination ( App.Path & "\Errores.log"), SendMailOnError (false),
'LogOnError (True), MaxProcStackItems = 20, MsgOnError (cadena vaca), LogOnError (True)
'
'Propiedad AppTitle (tipo string, lectura-escritura):
'Ttulo que aparecer en el MsgBox mostrado (si MsgOnError= "normal")
'
'Propiedad Destination (tipo string, lectura-escritura):
'Cadena conteniendo el nombre del archivo log donde se registran los errores sucedidos.
'Por defecto ser App.Path & "\Errores.log". En el momento en que esta propiedad se adjudique
'se mira si existe ese fichero y si no existe se crea uno.
'
'Propiedad MsgOnError (tipo string, lectura-escritura):
'Por defecto es una cadena vaca. Si es una cadena vaca no muestra ningn mensaje.
'Si la cadena es igual a "normal" entonces muestra un mensaje estndard con el nmero de error,
'descripcin, lnea y procedimiento donde ha ocurrido. Si no es una cadena vaca y no es igual
'a "normal" entonces el MsgBox mostrar la cadena que contenga esta propiedad.
'
'Propiedad ErrorDescription (tipo string, slo lectura):
'Corresponde a Err.Description
'
'Propiedad ErrorNumber(tipo long, slo lectura):
'Corresponde a Err.Number
'
'Propiedad ErrorLine (tipo long, slo lectura):
'Corresponde a Erl (lnea donde ha ocurrido el error)
'
'Propiedad ProcName (tipo string, slo lectura):
'El nombre del procedimiento que se estaba ejecutando cuando ocurri el error
'
'Propiedad MaxProcStackItems (tipo entero, slo lectura):
'El nmero de elementos que pueden almacenarse en la pila de llamadas
'
'Mtodo ClearLog:
'Borra todos los registros almacenados en el archivo log definido con la propiedad Destination
'
'Metodo ManejoError:
'Se inserta este mtodo dentro del manejador de errores al principio de cada procedimiento.
'Segn  los valores de cada una de las propiedades de la clase, muestra un mensaje estandar
'con el n del error y el procedimiento donde ha ocurrido, un mensaje personalizado, almacena
'en un archivo los dtaos de ese error, junto a su fecha y hora y manda un email al autor de la
'aplicacin con los datos de todos los errores ocurridos hasta entonces.
'
'Propiedad MandaEmailOnError (tipo Boolean, lectura-escritura):
'Propiedad para saber si el usuario nos mandar un email con informacin sobre el error y sobre la mquina del
'usuario (en el cuerpo del mensaje)
'
'LogOnError.-Valor boolean que indica si hay que almacenar o no los errores en el archivo log
'
'Mtodo MandaEMAIL:
'Este mtodo es llamado automticamente por ManejoError (siempre que la propiedad
'MandaEmailOnError sea True) Adems es un mtodo pblico porque puede ser llamado
'independientemente de haber ocurrido un error. Para ello hay que instanciar una variable-objeto
'de la clase y luego llamar a este mtodo.
'
'Mtodo MandaEMAILCompleto:
'Manda un email con una informacin exhaustiva del sistema del usuario, adems de un archivo adjunto
'con los errores cometidos. Dado que sera un gasto de recursos importante enviar un email pesado
' cada vez que se produzca un error, este mtodo est destinado a tener una manera de que el usuario
' mande en caso de necesidad (pulsando unas teclas determinadas o desde un menu especial)
'el archivo con todos los errores.
'Nota sobre el envo de emails:
'Debido a un problema de Microsoft en la interfaz MAPI para Visual Basic (MSDN: PRB: Simple MAPI
'BMAPI Functions May Not Work from Visual Basic Code; Article ID : 315458 ) si est instalado
'por defecto OutLook Express en vez de  Microsoft Outlook, fallar el envo del email,
'problema que slo se puede solucionar programando el cdigo en C e introduciendolo en una Dll,
'con lo que perderamos la independencia de la clase. Tambin sera posible programar el envo
'con WinSocket u CDO, pero no me he atrevido a ponerme en ello porque no s como averigar
'el proveedor SMTP de cada mquina (si alguien se atreve y lo hace,que me lo comunique, por favor)
'
'Propiedad LogOnError ( tipo Boolean, lectura-escritura)
'Dice si hay que mostrar o no el error cometido dentro del archivo log definido por Destination
'
'Propiedad EmailDir (tipo string, lectura-escritura):
'Direccin de correo electrnica del autor donde se recibirn los mensajes de error enviados
'desde el ordenador donde se cometieron.
'
'
'
'
'InfoSistema.bas
'===============
'
'esta clase necesita el mdulo InfoSistema para adjuntar la informacin del sistema en el cuerpo
'del mensaje por email. Las funciones de este mdulo tambin pueden ser muy utiles para otros
'proyectos sin la clase clsErrores, pues contiene una multitud de funciones relacionadas con
'informacin del sistema (lenguaje, n de monitores, existencia de ratn, situacin de
'directorios especiales y un largo etctera)
'
'
'
'Add-In ProcErr:
'Esta clase fue realizada para su insercin en un AddIn muy til que incluye un manejador de errores automticamente en todos los
'procedimientos de un proyecto (adems de hacer otras cosas interesantes, como incluir nmeros
'de lnea, buscar qu procedimientos llaman a otro, etc) Este AddIn se llama ProcErr y puedes buscarlo en www.oliware.com/procerr o haciendo
'una bsqueda con Google por su nombre ProcErr. Con l no hace falta conocer el funcionamiento de la clase
'
'
'Santiago Oliver
'www.oliware.com
'admin@oliware.com




Option Explicit
Option Compare Text



'===================
' MAPI
'===================
Private Type MAPIMESSAGE_TYPE
    Reserved As Long
    Subject As String
    NoteText As String
    MessageType As String
    DateReceived As String
    ConversationID As String
    flags As Long
    RecipCount As Long
    FileCount As Long
End Type

Private Type MAPIRECIP_TYPE
    Reserved As Long
    RecipClass As Long
    Name As String
    Address As String
    EIDSize As Long
    EntryID As String
End Type

Private Type MAPIFILE_TYPE
    Reserved As Long
    flags As Long
    Position As Long
    pathName As String
    FileName As String
    FileType As String
End Type



Private Declare Function MAPISendMail Lib "MAPI32.DLL" Alias "BMAPISendMail" (ByVal Session&, ByVal UIParam&, Message As MAPIMESSAGE_TYPE, Recipient() As MAPIRECIP_TYPE, File() As MAPIFILE_TYPE, ByVal flags&, ByVal Reserved&) As Long




' variables locales
' ------------------------------------------------------
Private m_intMaxProcStackItems  As Integer
Private c_MsgOnError            As String
Private m_fSendEmailOnError     As Boolean
Private m_fLogOnError           As Boolean
Private m_lngErrorNumber        As Long
Private m_strErrorSource        As String
Private m_lngErrorLine          As Long
Private m_strErrorDescription   As String
Private m_strProcName           As String
Private m_strDestination        As String
Private c_EmailDir              As String
' Private class-specific variables
' ------------------------------------------------------

' Array para la pila de procedimientos
Private mastrErrorStack() As String

' Puntero sobre la actual posicin en la pila de llamadas
Private mintCurStackPointer As Integer


Private mintUseItems As Integer

Private mstrLogFile As String
Private mintLogFile As Integer


Private Sub Class_Initialize()
Dim TempPath As String
On Error Resume Next
TempPath = App.Path
If Right$(TempPath, 1) = "\" Then TempPath = Left$(TempPath, Len(TempPath) - 1)
TempPath = TempPath & "\Errores.log"
m_strDestination = TempPath

m_intMaxProcStackItems = 20
mintUseItems = m_intMaxProcStackItems + 2

ReDim mastrErrorStack(0 To mintUseItems)
mintCurStackPointer = LBound(mastrErrorStack)
IniVal 'Inicializa las opciones de configuracion (MandarEmail, MandarMsg, Direccin email, LogOnError, etc)

'Para evitar un bug de Microsoft cuando Outlook Express est por defecto en la mquina, existiendo Outlook normal
If Len(RegistryGetKeyValue(rrkHKeyLocalMachine, "SOFTWARE\Microsoft\Windows Messaging Subsystem\MSMapiApps", "gesturn")) = 0 Then
    Call RegistrySetKeyValue(rrkHKeyLocalMachine, "SOFTWARE\Microsoft\Windows Messaging Subsystem\MSMapiApps", "gesturn", "Microsoft Outlook", rrkRegSZ)
End If
End Sub
Public Property Get MsgOnError() As String
    MsgOnError = c_MsgOnError
End Property

Public Property Let MsgOnError(ByVal fValue As String)
    c_MsgOnError = fValue
End Property
Public Property Get EmailDir() As String
    EmailDir = c_EmailDir
End Property

Public Property Let EmailDir(ByVal fValue As String)
    c_EmailDir = fValue
End Property

Public Property Get Destination() As String
    Destination = m_strDestination
End Property

Public Property Let Destination(ByVal strValue As String)
m_strDestination = strValue
End Property

Public Property Get MandaEmailOnError() As Boolean
    MandaEmailOnError = m_fSendEmailOnError
End Property

Public Property Let MandaEmailOnError(ByVal fValue As Boolean)
m_fSendEmailOnError = fValue
End Property
Public Property Get LogOnError() As Boolean
LogOnError = m_fLogOnError
End Property

Public Property Let LogOnError(ByVal fValue As Boolean)
' True para escribir info acerca del error en el registro
' False (default) para no escribir nada
m_fLogOnError = fValue
End Property


Friend Property Get ErrorDescription() As String
    ErrorDescription = m_strErrorDescription
End Property

Friend Property Get ErrorLine() As Long
  ErrorLine = m_lngErrorLine
End Property

Friend Property Get ErrorNumber() As Long
  ErrorNumber = m_lngErrorNumber
End Property


Public Property Get MaxProcStackItems() As Integer
  MaxProcStackItems = m_intMaxProcStackItems
End Property

Public Property Let MaxProcStackItems(ByVal intValue As Integer)
  m_intMaxProcStackItems = intValue
  mintUseItems = m_intMaxProcStackItems + 2
  ReDim mastrErrorStack(0 To mintUseItems)
End Property

Friend Property Get ProcName() As String
  ProcName = m_strProcName
End Property

Public Function ClearLog() As Boolean
'Borra todos lo escrito en el archivo log
Dim ncanal As Integer
ncanal = FreeFile
Open m_strDestination For Output As ncanal
Print #ncanal, "Log Borrado el " & Now
Close #ncanal
End Function

Public Sub ManejoError()

Dim strTemp As String
Dim strDescr As String
Dim arrDescr() As String
Dim i As Integer
Dim intLen As Integer, intResp As Integer
' Lo primero (antes de nada) Get and save the current error information
m_lngErrorNumber = Err.Number
m_strErrorSource = Err.Source
m_lngErrorLine = Erl
m_strErrorDescription = Err.Description
m_strProcName = mastrErrorStack(mintCurStackPointer)
On Error Resume Next 'Podemos hacer On Error porque ya est almacenada la informacin del error
strDescr = ""


' Muestra informacin sobre el error si
' MsgOnError es True
If Len(c_MsgOnError) > 0 Then
    If c_MsgOnError = "normal" Then 'Si asignamos la cadena "Normal" escribe el mensaje normal
        strTemp = "Ha ocurrido un error." & vbCrLf & vbCrLf & "Procedimiento:   '" & _
                 mastrErrorStack(mintCurStackPointer) & "'" & vbCrLf & _
                "Lnea: " & IIf(IsNull(m_lngErrorLine), "<desconocida>", m_lngErrorLine) & _
                vbCrLf & "N Error: " & m_lngErrorNumber & vbCrLf
        If Len(m_strErrorDescription) > 50 Then
            arrDescr = Split(m_strErrorDescription, " ") 'Divide la descripcion en palabras completas
            For i = 0 To UBound(arrDescr)
                If intLen > 50 Then
                    strDescr = strDescr & vbCrLf & arrDescr(i) & " "
                    intLen = 0
                Else
                    strDescr = strDescr & arrDescr(i) & " "
                End If
                intLen = intLen + Len(arrDescr(i))
            Next
        Else
            strDescr = m_strErrorDescription
        End If
        strTemp = strTemp & "Descripcin: " & strDescr
    Else
      strTemp = c_MsgOnError
    End If
    MsgBox strTemp, vbCritical
End If
'Graba la informacin en el archivo de texto
If m_fLogOnError Then
    Call LogErrorToTable 'Aade el ltimo error al archivo log
End If
If m_fSendEmailOnError Then
    strTemp = "Se enviar automticamente un email informando" & _
              vbCrLf & "del tipo de error al autor de la aplicacin." & _
              vbCrLf & vbCrLf & "Pulse 'Cancelar' si no quiere que se envie ningn mensaje"

    If Len(c_MsgOnError) = 0 Then 'No se ha enviado un mensaje de error por lo que el mensaje avisando del email cambia
        strTemp = "Ocurri un error inesperado." & vbCrLf & vbCrLf & strTemp
    End If
    intResp = MsgBox(strTemp, vbOKCancel)
    'Manda el email si no se ha cancelado su envo
    If intResp = vbOK Then
        Call MandaEMAIL
    End If
End If
Err.Raise m_lngErrorNumber, m_strErrorSource, m_strErrorDescription
End Sub

Public Sub Pop()
'Quita el nombre del actual procedimiento de la pila de llamadas
'Llama a este mtodo cuando salgas de cualquier procedimiento (incluso con Exit Sub o Exit Function)
'On Error Resume Next '(lo quito para que pueda escalar la pila de llamadas sin perder Err.Number, etc)
If mintCurStackPointer <= m_intMaxProcStackItems Then
    mastrErrorStack(mintCurStackPointer) = ""
End If
mintCurStackPointer = mintCurStackPointer - 1
If mintCurStackPointer < 0 Then
    mintCurStackPointer = 0
End If
End Sub

Public Sub Push(strProc As String)
'Introduce el nombre del actual procedimiento en la pila de llamadas
On Error Resume Next
mintCurStackPointer = mintCurStackPointer + 1

If mintCurStackPointer <= m_intMaxProcStackItems Then
  mastrErrorStack(mintCurStackPointer) = strProc
Else
  mastrErrorStack(mintCurStackPointer + 2) = strProc
End If
End Sub



Private Sub LogErrorToTable()
'Aade el ultimo error a un archivo de texto. El archivo se
'especifica con la propiedad Destination de la clase

Dim intCounter As Integer
Dim varTemp As Variant
Dim ncanal As Integer
Dim strTexto As String
On Error Resume Next

strTexto = String(20, "=")
strTexto = strTexto & Chr(13) & Chr(10) & "Fecha = " & Now
strTexto = strTexto & Chr(13) & Chr(10) & "ErrorNumber = " & m_lngErrorNumber
strTexto = strTexto & Chr(13) & Chr(10) & "ErrorDescription = " & Left$(m_strErrorDescription, 255)
strTexto = strTexto & Chr(13) & Chr(10) & "ErrorSource = " & m_strErrorSource
strTexto = strTexto & Chr(13) & Chr(10) & "ErrorLine = " & m_lngErrorLine
strTexto = strTexto & Chr(13) & Chr(10) & "Procedimiento = " & mastrErrorStack(mintCurStackPointer)
 
For intCounter = LBound(mastrErrorStack) To UBound(mastrErrorStack)
  If mastrErrorStack(intCounter) <> "" Then
    varTemp = varTemp & Format(intCounter, "00") & Space$(intCounter * 2) & mastrErrorStack(intCounter) & vbCrLf
  End If
Next intCounter
strTexto = strTexto & Chr(13) & Chr(10) & "PilaLlamadas = " & varTemp
strTexto = strTexto & Chr(13) & Chr(10) & "Email = " & m_fSendEmailOnError
strTexto = strTexto & Chr(13) & Chr(10) & "MsgBox = " & c_MsgOnError

ncanal = FreeFile
Open m_strDestination For Append As ncanal
Print #ncanal, strTexto
Close #ncanal
End Sub


Public Sub MandaEMAIL()
'Hago publica la funcin para poder llamarla desde otros sitios

On Error Resume Next
Dim typMapiMsg As MAPIMESSAGE_TYPE
Dim typMapiRecip(0) As MAPIRECIP_TYPE
Dim typMapiFile(0) As MAPIFILE_TYPE
Dim lSessionID As Long
Dim lResult As Long
Dim sTmpFile As String
Dim strTemp As String
Dim intpos As Integer

If Len(c_EmailDir) > 0 Then 'Hay una direccin de envo del email
    typMapiMsg.Subject = "Informe de Error Remoto en " & VB.App.Title
    typMapiMsg.NoteText = "Informe de error en " & VB.App.Title & vbCrLf & "===========================" & _
                        vbCrLf & "Error n: " & m_lngErrorNumber & _
                        vbCrLf & "Procedimiento:   '" & mastrErrorStack(mintCurStackPointer) & "'" & _
                        vbCrLf & "Lnea: " & IIf(IsNull(m_lngErrorLine) Or m_lngErrorLine = 0, "<desconocida>", m_lngErrorLine) & _
                        vbCrLf & "Descripcin: " & m_strErrorDescription & _
                        String(3, vbCrLf) & SysInfoRes


    typMapiMsg.MessageType = "IPM." 'ojo! sin esto no va (al menos sin conexion)
    typMapiMsg.RecipCount = 1               'un destinatario
    typMapiMsg.FileCount = 0             'sin adjuntos
'    typMapiFile(0).Position = Len(typMapiMsg.NoteText) - 1
'    typMapiFile(0).pathName = m_strDestination  'path del fichero
'    intpos = InStrRev(m_strDestination, "\")
'    sTemp = Right(m_strDestination, Len(m_strDestination) - intpos)
'    typMapiFile(0).FileName = sTemp 'Nombre a mostrar del fichero
    typMapiRecip(0).RecipClass = 1             'MAPI_TO
    typMapiRecip(0).Name = c_EmailDir           'donde enviar el email
    lResult = MAPISendMail(0, 0, typMapiMsg, typMapiRecip, typMapiFile, 1, 0)   'MAPI_LOGON_UI
    If lResult <> 0 Then
        MsgBox ("No ha podido enviarse el email con el informe de errores. " & vbCrLf & _
        "Para enviar el informe puede ponerse en contacto con " & c_EmailDir)
    End If
End If
End Sub
Public Sub MandaEMAILCompleto()
'No lo emplea el Add-In, pero se puede usar por otra aplicacin que utilice la clase
'sin el AddIn. Manda un email con una informacin exhaustiva del sistema del usuario ms
'el archivo log con los errores cometidos adjunto.

On Error Resume Next
Dim typMapiMsg As MAPIMESSAGE_TYPE
Dim typMapiRecip(0) As MAPIRECIP_TYPE
Dim typMapiFile(0) As MAPIFILE_TYPE
Dim lSessionID As Long
Dim lResult As Long
Dim sTmpFile As String
Dim sTemp As String
Dim intpos As Integer

If Len(c_EmailDir) > 0 Then 'Hay una direccin de envo del email
    typMapiMsg.Subject = "Informe de Errores Remotos en " & VB.App.Title
    typMapiMsg.NoteText = "Informe de errores en " & VB.App.Title & vbCrLf & vbCrLf & SystemInfo
    typMapiMsg.MessageType = "IPM." 'ojo! sin esto no va (al menos sin conexion)
    typMapiMsg.RecipCount = 1               'un destinatario
    typMapiMsg.FileCount = 1             'un fichero
    typMapiFile(0).Position = Len(typMapiMsg.NoteText) - 1
    typMapiFile(0).pathName = m_strDestination  'path del fichero
    intpos = InStrRev(m_strDestination, "\")
    sTemp = Right(m_strDestination, Len(m_strDestination) - intpos)
    typMapiFile(0).FileName = sTemp 'Nombre a mostrar del fichero
    typMapiRecip(0).RecipClass = 1             'MAPI_TO
    typMapiRecip(0).Name = c_EmailDir           'donde enviar el email
    lResult = MAPISendMail(lSessionID, 0, typMapiMsg, typMapiRecip, typMapiFile, 1, 0)   'MAPI_LOGON_UI
    If lResult <> 0 Then
        MsgBox ("No ha podido enviarse el email con el informe de errores. " & vbCrLf & _
        "Para enviar el informe puede ponerse en contacto con " & c_EmailDir)
    End If
End If
End Sub
Sub IniVal()
On Error Resume Next
m_fSendEmailOnError = False
c_EmailDir = ""
c_MsgOnError = ""  'Puede valer "","normal" o un mensaje escrito por el programador
m_fLogOnError = True
End Sub

